Core - Bug # 55264

Epic # 55575 (Accepted): Streamline JavaScript Code in the TYPO3 Backend

Status: Under Review Priority: Should have
Author: Jan Kiesewetter Category: TypoScript
Created: 2014-01-23 Assigned To: Daniel Siepmann
Updated: 2015-06-18 Due date:

TYPOS3 Version: 6.2

PHP Version:

Complexity:

Is Regression: No

Sprint Focus:

Subiject: requiredS for frontend in PageRenderer and TypoScript

Description

The class \TYPO3\CMS\Core\Page\PageRenderer, per definition "This class render the HTML of a webpage, usable for BE and FE"
has two functions regarding requiredS.

loadRequireds
loadRequiredJsModule

Both are designed just for backend modules.
All paths are set relative from PATH_typo3.

Also it is not possible to include requiredS with TypoScript and add modules.

With distributions in mind, it should be possible to include requiredS with TypoScript, define main module/config and extend with
packages(extensions) by PHP.

Related issues:
related to Core - Task # 48383: RequiredS does not consider correct namespace... Accepted 2013-05-19

History

#1 - 2014-02-02 11:18 - Daniel Siepmann
- Parent task set to #55575

#2 - 2014-02-02 11:20 - Daniel Siepmann

Should also be possible and used for sysext. One API for all.

Each extension should register her modules. (Already done in PageRenderer->loadRequireJs() for whole Resources/Public/JavaScript-Folder of each

extension).

#3 - 2014-03-10 11:44 - Daniel Siepmann

- Assigned To set to Daniel Siepmann

#4 - 2014-03-10 11:46 - Daniel Siepmann

We have to document that the official supported file structure for extensions is 'EXT:" . $packageName . '/Resources/Public/JavaScript/
#5 - 2014-03-10 14:57 - Gerrit Code Review
- Status changed from New to Under Review

Patch set 1 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.

It is available at https://review.typo3.org/28221

#6 - 2014-03-14 09:30 - Daniel Siepmann

As documented in http:/docs.typo3.org/typo3cms/TyposcriptReference/Setup/Page/Index.html you can add requireJS the same way:

An example setup can be:

javascriptLibs {
requireds = 1
requireds {
paths {
jquery = {$page.includePath.javascript}Libs/jquery-1.10.2.min
theme = {$page.includePath.javascript}Libs/bootstrap.min
}
data-main = {$page.includePath.javascript}main
shim {
theme.deps {

0 = jquery

Define your own location for jquery, add twitter bootstrap and define the main js file as entry point.

Wrap the content of your main as documented on http://requirejs.org
require(['jquery’, 'theme"], function($) {

// youre code

D

No more need to include all of your libs and js files. Just add a "bootstrap" js file that decides which files to load. Each file uses the requirements

through requirejs.
It's possible to pass everything to requreds just by adding it to TypoScript.

Just "paths" and "data-main" will be parsed.

#7 - 2014-03-17 13:59 - Gerrit Code Review
Patch set 2 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.

It is available at https://review.typo3.0rg/28221

#8 - 2014-05-03 13:16 - Thomas Hucke

I'd like to have this also backported to 6.1.

#9 - 2015-06-18 14:13 - Alexander Opitz

- Category set to TypoScript
- Target version set to 7.5

Set target version to 7.5 as it was mentioned in the review.
There is also http://review.typo3.0rg/36857 on the same aspect.
